/*
 * _version.h
 *
 *  Created on: 2. apr. 2021
 *      Author: teig
 */


#ifndef VERSION_H_
    #define VERSION_H_

    // "%u.%u", XCC_VERSION_MAJOR, XCC_VERSION_MINOR = "1404.1"

    #define BEEP_BRRR_VERSION_STR "0.8.42" // x.y.zz
    #define BEEP_BRRR_              v0842
    #define BEEP_BRRR_DATE __DATE__
    // OBSERVE THAT RENAMING ANYTHING ALSO RENAMES HERE!

    // TODO XTA timing fails
    // TODO button noise still with me (not that much!)

    // 26Jul2022 v0842 BEEP-010 DEBUG_SET_PIXEL_IN_BUFFER_TEST new and 0
    //                 Now display does not waste any pixels! So: it works!
    //                 SCREEN_ABOUT mor flexibel layout with getCursor_x and getCursor_y new
    //                 XFLASHED
    //                 Constraints tile[0]: C:8/8 T:10/8 C:32/29 M:6220 S:10168 C:40596 D:11456
    //                 Constraints tile[1]: C:8/4 T:10/4 C:32/13 M:58916 S:26788 C:29116 D: 3012
    // 26Jul2022 v0841 See "2022 07 26 v0841 setPixel_in_buffer_test.txt" plus photos
    //                 Display has empty pixel-lines, and I have discovered why. 
    //                 See setPixel_in_buffer of next version
    // 19Jul2022 v0840 Same as v0838: it works. _global_bug_fix.h is new
    // 19Jul2022 v0839 For XMOS: this does not output values in logger_task. See BEEP-009 in file logger.xc
    // 19Jul2022 v0838 Only comments changed, same version
    //                 For XMOS: this runs like it should. See BEEP-009 in file logger.xc
    //                 BEEP-009: an extra dummy xassert in logger_task seems to be necessary to have the
    //                 curve getting out on the DAC over I2C. Reported to XMOS as mail only to support@xmos.com
    //                 since this seems to be the same kind of error as earlier reported #183751
    //                 "linker or xmap error: blips in sound output switched on and off by adding
    //                 an unused xassert(false)!"
    // 18Jul2022 v0838 NUM_SECTIONS_FILTER_A and NUM_SECTIONS_FILTER_Y allows for cascading anti-alias
    //                 filters with dsp_filters_biquads instead of just one dsp_filters_biquad
    //                 Runs, but only after some fine tuning: BEEP-009: see above
    // 21Jun2022 v0837 dsp_task_y and logger_task:
    //                 wait_for_task_b instead of allow_state_handling, which handled logger_task and ..task_b
    //                 was not smart. This also allowed for dropping allow_sch_yb_knock. MUCH BETTER! Runs
    //                 XFLASHED
    //                 Constraints tile[0]: C:8/8 T:10/8 C:32/29 M:62036 S:10152 C:40516 D:11368
    //                 Constraints tile[1]: C:8/4 T:10/4 C:32/13 M:58900 S:26772 C:29116 D: 3012
    // 21Jun2022 v0836 HANDLE_RESPONSE_FROM_TASK_B is new, Runs
    // 21Jun2022 v0835 Equal to below, no printout. Tests if DAC4 is present. Runs
    // 20Jun2022 v0834 Seems to work, but compile with printout, see log "2022 06 20 v0834 log.txt"
    // 18Jun2022 v0833 Tolal rewrite of dsp_task_y into more functions, named HANDLE_..
    //                 preparing for next version, where new states will be introduced.
    //                 Was necessary to make it readable. Also one comm to logger_task instead of three.
    //                 Runs. Used less memory:
    //                 Constraints tile[0]: C:8/8 T:10/8 C:32/29 M:61964 S:10144 C:40452 D:11368
    //                 Constraints tile[1]: C:8/4 T:10/4 C:32/13 M:58948 S:26836 C:29100 D: 3012
    // 17Jun2022 v0832 Intermediate value, not commited
    // 17Jun2022 v0831 Not existing
    // 13Jun2022 v0830 BEEP-008 understood (that logger_task DAC4 will yield when Display_screen is running)
    // 13Jun2022 v0829 Now both NUM_SAMPLES_PER_BATCH 1024 and 512 go to 4 kHz after FFT,
    //                 just remember to do a Clean project after changing them
    //                 NUM_SAMPLES_PER_BATCH == 1024 is now "default". Logs:
    //                 65 ms late=0
    //                 per_us:100 tim:256000 late:0  OK:1000 ERR:0  ok:257000 err:0 max_us:81, max:1350000
    //                 See "2022 06 13 v0829 build log.txt"
    //                 Constraints tile[0]: C:8/8 T:10/8 C:32/29 M:61996 S:10144 C:40452 D:11400
    //                 Constraints tile[1]: C:8/4 T:10/4 C:32/13 M:59492 S:27268 C:29036 D: 3188
    // 09Jun2022 v0828 Chasing BEEP-006 "late=" and "late:". Now both are zero! SOLVED!
    //                 LOGGER_PERIODE_CMD_A_TICKS now can be taken much lower since MUM_DAC4_A_BYTES
    //                 used on every curve value, instead of MUM_DAC4_AB_BYTES
    // 07Jun2022 v0827 BEEP-007 solved. DEBUG_LOGGER_SKIP_CURVES 0 and 1 works. Deadlock removed.
    //                 dsp_task_y needed a guard before next curve was allowed. This was seen when 
    //                 I didn't send any curve to the scope, ie. logger_task wanted a new curve too fast for dsp_task_y
    //                 Now I can really try to find BEEP-006
    // 26May2022 v0826 send_pair now is sed_trio, receive is receive_trio. Send ch_data_ack_ui along with data
    //                 from ..task_b to ..task_x then ..task_y. any_button_any_event_t for transient button state
    //                 Quite a lot seem to work, but I have not looked at the fine detail with the scope
    // 25May2022 v0825 BEEP-006 is the "43 ms late:50" syndrom.
    //                 Tested with debug_do_extra_sch_yb every other time, and I still got 50:
    //                 43 ms late:50(1) dsp:21107 us max:0.000771 12952(3298) button:50 0 0 0
    //                 43 ms late:50(0) dsp:21106 us max:0.000345 5792(16A0) button:50 0 0 0
    // 25May2022 v0824 dsp_task_y seems to take to much comms with ..task_b (NO! see above), since was_late_cnt is 50:
    //                 43 ms late:50 dsp:21124 us max:0.004547 76300(12A0C) button:50 0 0 0
    //                 NUM_BATCHES_TO_COUNT = 50 so one was_late_cnt for each
    // 21May2022 v0823 DO_ONE_FRAME_DELAY is new
    // 21May2022 v0822 The curces now are flattened in the logger_task around button presses, but no delay of frames yet,
    //                 to handle "flatten previous", see any_button_any_event_t. RUNS
    // 19May2022 v0821 any_button_any_event_t and frame_usage_cnt_e new, to handle dropping of frames around button presses
    //                 See "2022 05 19 11.55 v0821 log.txt"
    // 18May2022 v0820 PORTS_1D_1N_AT_5 toggles on every event from buttons to see how much noise from the buttons takes
    // 14May2022 v0819 curve_is_all_zeros[] of DAC4_context_t is new. So now zero values works, showing zero values in logger_task
    // 14May2022 v0818 Just a commit to see if no DAC gain and headset_gain_is_off also stops curves for v0817
    //                 It did not! But there was no 480 Hz in the headset, which is the reason I moved the code up
    // 10May2022 v0817 DO_FILTERS is new
    //                 See https://www.teigfam.net/oyvind/blog_notes/219/fig25_219_signal_flow_beep_brrr_oyvind_teig_10May2022.pdf
    //                 FREQ_MAX_VALUE_LOG is new, for no-auto scaling. Last with auto-scaling was v0813
    //                 For future analysis of the XTA reports:
    //                   v0815 XTA reports: fails 4 times Min Core Frequency: 534 MHz
    //                   v0636 XTA reports: fails 4 times Min Core Frequency: 522 MHz
    //                   v0619 XTA reports: fails 4 times Min Core Frequency: 534 MHz
    //                   v0501 XTA reports: fails 4 times Min Core Frequency: 534 MHz
    //                   v0405 XTA reports: fails 4 times Min Core Frequency: 522 MHz
    //                 XFLASHED
    // 10May2022 v0815 _Beep_dsp_params.h added (no corersponding .xc file)
    //                 Filter b now moved to dsp_task_y (filter_y_iir_biquad_params)
    //                 See XTA report above
    // 05May2022 v0814 Snapshot experimenting with filter and gain of logger
    // 05May2022 v0813 Starting to understand iir_biquad_params_t (filter not used yet)
    // 02May2022 v0812 XFLASHED
    //                 Constraints tile[0]: C:8/8 T:10/8 C:32/28 M:50620 S: 9656 C:30536 D:10428
    //                 Constraints tile[1]: C:8/4 T:10/4 C:32/11 M:33924 S:13516 C:18480 D: 1928 (why so much less than last time?)
    // 02May2022 v0811 Runs
    //                 Some dependencies modfied in libs since they seem to work with those now required,
    //                 and that these libs seem to be the last versions before XTC Tools:
    //                 in module_build_info                               DEPENDENT_MODULES
    //                 lib_i2c(5.0.0)                                     none
    //                 lib_logging(3.1.1)                                 none
    //                 lib_xassert(4.1.0)                                 none
    //                 lib_mic_array(4.5.0)                               lib_logging(>=3.0.0) lib_xassert(>=4.0.0) lib_dsp(>=6.0.0)
    //                 lib_i2s(2.2.0)                     Modified there: lib_logging(>=3.0.0) lib_xassert(>=4.0.0)
    //                 lib_dsp(6.2.1)                                     lib_logging(>=3.0.0)
    //                 lib_mic_array_board_support(2.2.0) Modified there: lib_i2c(>=5.0.0)
    // 02May2022 v0810 Runs
    //                 log_logging   updated to 3.1.1 from https://github.com/xmos/lib_loggin. Was 2.1.0 (xmake stopped, warning not tolerated)
    //                 lib_dsp       updated to 6.2.1 from https://github.com/xmos/lib_dsp     Was 3.1.0
    //                 lib_mic_array updated to 4.5.0 from https://www.xmos.ai/libraries/      Was 3.0.1 https://api.github.com/repos/xmos/lib_mic_array/zipball/v4.5.0 (Next is for XTC)
    //                 lib_xassert   updated to 4.1.0 from https://github.com/xmos/lib_xassert Was 3.0.0
    //                 lib_src       is new     2.2.0 from https://github.com/xmos/lib_src (not used yet)
    //                 The code seems to run, despite these warnings:
    //                   WARNING: Required version of lib_i2c is >=4.0.0 and actual version has greater major version: 5.0.0. There could be API incompatibilities.
    //                   WARNING: Required version of lib_logging is >=2.1.0 and actual version has greater major version: 3.1.1. There could be API incompatibilities.
    //                   WARNING: Required version of lib_xassert is >=3.0.0 and actual version has greater major version: 4.1.0. There could be API incompatibilities.
    //                   Using build modules: lib_i2c(5.0.0) lib_logging(3.1.1) lib_xassert(4.1.0) lib_mic_array(4.5.0) lib_i2s(2.2.0) lib_mic_array_board_support(2.2.0) lib_dsp(6.2.1)
    //                 So I removed all version requirements from Makefile:
    //                   USED_MODULES  = lib_i2c(>=4.0.0) lib_logging lib_xassert lib_mic_array(>=3.0.0)
    //                   USED_MODULES += lib_i2s(>=2.2.0) lib_mic_array_board_support(>=2.1.0)
    //                   USED_MODULES += lib_dsp(>=3.0.0)
    //                 This did not remove the warnings, so I assume that the requirements come from some of the libraries
    // 25Apr2022 v0805 PROCESS_FREQUENCY_HZ 16000, NUM_SAMPLES_PER_BATCH 512. Works! XFLASHED
    //                 === SAMPLING ==  ================== FFT =================    ==== SPLITTING IN 2 ====
    //                 p-freq  p-num -> Nyquist-f  FFT-bins  HZ_PER_BIN batch-ms -> spectrum-ms f-max ix-max
    //                 16000 /  512 ->      8000 /    256 = 31.25            32 ->          16  4000  [127]
    // 25Apr2022 v0804 PROCESS_FREQUENCY_HZ 16000: Seems to work! Now spectrum goes to 4 kHz
    //                 NUM_SAMPLES_PER_BATCH 1024: HZ_PER_BIN = 15.61 @ 16 kHz for 64 ms, max 3998 Hz at end pos [255]
    // 25Apr2022 v0803 BEEP-005 hangs. Deadlock.
    //                   Participants:
    //                     dsp_task_y, Handle_Beep_BRRRR_task_b and buffer_task_x
    //                   In Handle_Beep_BRRRR_task_b a button started it, some times. At first I thought
    //                   it was the Display_screen I2C, but it was the general delay that started a race.
    //                   Solved:
    //                      1. Had commented away some code in buffer_task_x
    //                      2. In dsp_task_y the initial data_sch_knock could not get the result in a select,
    //                         it had to be immediately below, else possible deadlock
    //                 Constraints tile[0]: C:8/8 T:10/8 C:32/28 M:48076 S: 8976 C:28992 D:10108
    //                 Constraints tile[1]: C:8/4 T:10/4 C:32/11 M:41744 S:22732 C:22732 D: 1860
    // 24Apr2022 v0802 PROCESS_FREQUENCY_HZ 12000, ie. PROCESS_EVERY_N_SAMPLE 4 goes to 3 kHz, but the spectra
    //                 some times are VERY noisy and something deadlocks after some button presses
    //                 Will go on with this. Set PROCESS_FREQUENCY_HZ 8000 and all seems to be fine, as v0712 and below
    // 24Apr2022 v0801 Some problem, also with v0800, comitting now to go back. Rebuild all helped.
    //                 PROCESS_EVERY_N_SAMPLE       3 for the first time. STOPS with no warning
    //                 NUM_SAMPLES_PER_BATCH 1024 again
    // 23Apr2022 v0800 NUM_SAMPLES_PER_BATCH is new, and given value 2048 to get HZ_PER_BIN 3.905
    //                 Now index 255 is 995 Hz, ie.3.9 HZ_PER_BIN, but the spectrum stops at the same frequency of course! About 2 kHz
    //                 Removed param APPLICATION_NOTE from Makefile and then instead making everything like 219 (AN00219)
    // 19Apr2022 v0712 Discovered XCC_VERSION_MAJOR and XCC_VERSION_MINOR, obsoletes XTIMECOMPOSER_VERSION_STR
    // 18Apr2022 v0711 logger_task with both curves in DAC4 CHA, 156us * 256 bins = 40ms each.
    //                 HZ_PER_BIN 7.81 Hz/bin -> 992 Hz at pos [127]
    //                 Constraints tile[0]: C:8/8 T:10/8 C:32/28 M:47492 S: 8366 C:29056 D:10100
    //                 Constraints tile[1]: C:8/4 T:10/4 C:32/11 M:41712 S:22708 C:17152 D: 1852
    //                 xflashed
    // 18Apr2022 v0710 logger_task now displays both curves, from the same FFT in DAC4 CHA, CHB (takes too long)
    // 16Apr2022 v0709 logger_task now displays both curves, but not from the same FFT
    // 16Apr2022 v0708 logger_task now gets all the spectra from dsp_task_y
    //                 xflashed
    // 15Apr2022 v0707 logger_task frames the spectrum more correctly with if_port_commands.write_port
    //                 See "2022 04 15 v0705 framing with 1I vs. DAC4 CHD.png" for how it WAS
    //                 See "2022 04 15 v0707 framing with 1I vs. DAC4 CHD.png" for how it NOW IS
    //                 Also, no "DC value" between curves. xflashed
    // 14Apr2022 v0706 timeerafter_ticks in logger_task now gives no-slip timer intervals
    // 14Apr2022 v0705 FIRST VERSION THAT SHOWS THE SPECTRUM ON DAC4 CHA OVER 70 ms. (PERIODE_TICKS 273 us)
    //                 Synch with p_scope_1i_1m XS1_PORT_1I or CHD
    //                 DO_DISPLAY_SCREEN_OFTEN 0
    //                 See "2022 04 14 v0705 PERIODE_TICKS 273 977 Hz.png"
    //                 xflashed on board #1
    //                 Constraints tile[0]: C:8/8 T:10/8 C:32/28 M:47492 S: 8366 C:29056 D:10100
    //                 Constraints tile[1]: C:8/4 T:10/4 C:32/11 M:41600 S:22700 C:16944 D: 1956
    // 14Apr2022 v0704 See "2022 04 14 v0704 PERIODE_TICKS_ 300 DAC4 and simultaneously display.png"
    // 14Apr2022 v0703 See "2022 04 14 v0703 PERIODE_TICKS_ 1500 DAC4 and simultaneously display.png"
    // 13Apr2022 v0702 Experimenting with logger_task PERIODE_TICKS 5 ms gives <1% late and 1.3 secs for the
    //                 whole curve including 6 display writes of 120 ms each. This is not what I'm after!
    // 13Apr2022 v0701 DO_DISPLAY_SCREEN_OFTEN 1 and "2022 04 13 v0701 DAC4 424 ms and display ch3.png"
    //                 PORTS_1D_1N_AT_3 expanded to go around all Display_screen and we see that it does take
    //                 space intermingled with DAC4. This is quite ok. Maybe the logger_task PERIODE_TICKS should
    //                 be so long that writing to the display does not make it later? After all, all timeouts
    //                 are now "late":
    //                   tim 0 late 25344  OK 99 ERR 0  ok 25344 err 0
    //                   tim 0 late 25600  OK 100 ERR 0  ok 25600 err 0
    // 13Apr2022 v0700 I2C to DAC4 MCP4728 I2C_ADDRESS_OF_DAC4 now works. Also with Display_screen, they seem to
    //                 alternate, but they are intermingled. See png below. Not checked the actual values going
    //                 out from the MCP4728.
    //                 DO_DISPLAY_SCREEN_OFTEN 1: "2022 04 13 v0700 DAC4 424 ms and display.png"
    //                 DO_DISPLAY_SCREEN_OFTEN 0: "2022 04 13 v0700 DAC4 220 ms alone.png"
    //                 Constraints tile[0]: C:8/8 T:10/8 C:32/28 M:47492 S: 8328 C:29092 D:10072
    //                 Constraints tile[1]: C:8/4 T:10/4 C:32/11 M:41560 S:22668 C:16960 D: 1932
    // 10Apr2022 v0644 Commit to get v0632 for XFLASHing Mic board #1
    // 08Apr2022 v0643 Checking in for the seemingly dead p_scope_1i_1m = XS1_PORT_1I (v0625 checkout solved nothing, or using board #1)
    // 07Apr2022 v0642 port_tile0_task.h and port_tile0_task.xc are new. Not yet used.
    // 06Apr2022 v0641 do_calcs.sqrt = true and less debug, runs, but DAC4 does not always follow
    // 06Apr2022 v0640 error_info_t made much shorter and my_dsp_magnitude simplified. Runs with much debug_print
    // 04Apr2022 v0639 DOES NOT RUN: Variable length arrays are supported (see below)
    // 04Apr2022 v0638 DOES NOT RUN
    //                 Variable length arrays seem not be supported in interface calls (write_reg_ok and write_display_ok)
    //                 Fixed use of I2C_MASTER_IOF_SINGLE_CLIENT etc.
    // 01Apr2022 v0637 MUM_DAC4_ABCD_CHANNELS * 2 used in logger_task
    // 01Apr2022 v0636 SCOPE_TRIGGER_OFF_VAL used
    // 01Apr2022 v0635 More in logger_task
    // 31Mar2022 v0634 More on logger_task and two new files: DAC4_mcp4728.h DAC4_mcp4728.xc. Not tested, but compiles
    // 23Mar2022       Testing
    // 11Mar2022 v0633 The if-test mentioned below removed. Not needed, therefore also removed headset_gain_is_off
    //                 in mics_in_headset_out_task_a. Works NO BLIP!
    // 11Mar2022 v0632 Version with no BLIPS or BLIPS, search for v0632 in mics_in_headset_out.xc
    //                 Ticket to XMOS: "linker or xmap error: blips in sound output switched on and off by
    //                 adding an unused xassert(false)". XMOS ticket number #183751 (also see above)
    //                 XFLASHED. This version exercises all three scope outputs and writes to the display after
    //                           each measurement. But buttons all of a sudden go unresponsive and the LED starts
    //                           to blink faster, even if sound goes through to the headset.
    // 10Mar2022 v0631 dummy_avoid_blips_cnt xassert(false) seems to remove BLIPS!
    // 10Mar2022 v0630 See PORTS_1D_1N_AT_31. No BLIP in this Display_screen in this case!
    // 10Mar2022 v0629 BLIP follows Display_screen, but not every time
    // 10Mar2022 v0628 DO_DISPLAY_SCREEN_OFTEN is new
    // 09Mar2022 v0627 delay_milliseconds (2000) after first Display_screen to read SCREEN_ABOUT
    //                 TODO: Needs TEST_HEADSET_BUFFER_TASK 2 and headset_buffer_task to avoid BLIPS
    //                 Constraints tile[0]: C:8/8 T:10/8 C:32/27 M:47204 S: 8264 C:28884 D:10056
    //                 Constraints tile[1]: C:8/5 T:10/5 C:32/ 9 M:39632 S:21820 C:15992 D: 1820
    //                 XFLASHED
    // 09Mar2022 v0626 A single ch_headset_out <: FIX16_UNITY; initially in mics_in_headset_out_task_a removed
    //                 This runs like a dream, with display update for every cycle (for one spectrum, only)
    //                 NO BLIPS
    // 08Mar2022 v0625 NO BLIPS! TEST_HEADSET_BUFFER_TASK 2. MAGIC!
    // 07Mar2022 v0624 BEEP-004 chasing the one-sec blip. I think this fixed it. I did som int32_dB in task_a
    //                 No blip at all here. But then, SEND_LONG_MESSAGE_ACROSS_TILES_INIT is false
    // 07Mar2022 v0623 BEEP-004 Testing headset_buffer_task,
    //                 TEST_HEADSET_BUFFER_TASK==1 did not help
    //                 TEST_HEADSET_BUFFER_TASK==2 gives these blitches once per second, not as problematic
    //                 See https://www.xcore.com/viewtopic.php?f=37&t=8244&p=39275#p39275
    // 06Mar2022 v0622 BEEP-004 SEND_LONG_MESSAGE_ACROSS_TILES_INIT true pinpoints the blipping in the headset after v0606
    //                 See https://www.xcore.com/viewtopic.php?f=37&t=8244 "Glitches in UAC2 while doing playback"
    // 06Mar2022 v0621 Same version
    // 06Mar2022 v0621 BEEP-004 It's not send_pair, if I remove it, same shit
    // 06Mar2022 v0620 BEEP-004 I have a major problem with the sample outputs to the headset.
    //                 Several times per seconds there is a click and a muted period, sounding like blipping.
    //                 It's not debug_print, it's not xscope, it's not DO_DSP_RESULTS_TO_DISPLAY true, even
    //                 if that makes the period longer, I know it's not I2C to the display.
    //                 It's not i2c_master_single_port and i2s_task being distributed
    // 28Feb2022 v0619 My i2c tasks now have one shared i2c_general_commands_if instead of one
    //                 if_i2c_display_command in addition, on the side. There is no problem with allowing
    //                 any task that has access to my external i2c to have access to all commands.
    //                 The was a remain of the _Aquarium_1_x project, not needed here.
    //                 One less channel on tile[0] (27 instead of 28)
    //                 Constraints tile[0]: C:8/8 T:10/8 C:32/27 M:52516 S: 8264 C:33908 D:10344
    //                 Constraints tile[1]: C:8/4 T:10/4 C:32/ 9 M:39744 S:21805 C:16128 D: 1812
    // 27Feb2022 v0618 DEBUG_MIC_SAMPLES_INCREASING detected one value not appearing in dsp_task_y
    //                 because of a NUM_MIC_SAMPLES range test error in mic_samples_info_fill_buffer
    //                 Test code still present
    //                 DEBUG_MIC_SAMPLES_INCREASING tested OK all the way including final destination dsp_task_y
    //                 XFLASH'ed
    //                 Constraints tile[0]: C:8/8 T:10/8 C:32/28 M:52604 S: 8312 C:33944 D:10348
    //                 Constraints tile[1]: C:8/4 T:10/4 C:32/ 9 M:39344 S:21796 C:15736 D: 1812
    // 25Feb2022 v0617 With something as simple as just the max value, see how freq_max_value.ix shows up (in the display):
    //                 180 Hz at 23
    //                 360 Hz at 46
    //                 560 Hz at 72 (69)
    //                 720 Hz at 92
    //                 Don't know why 560 Hz is off, but anyway!
    //                 Used https://www.szynalski.com/tone-generator/
    // 25Feb2022 v0616 q24_signed_to_str now converts q8_24 of -128.000 correctly!
    //                 Lots of debug code present
    // 24Feb2022 v0615 One special pair of values to my_dsp_math_multiply_sat, v0615 (-12121068 and 335544320)
    // 24Feb2022 v0614 See "2022 02 24 15.36 v0614 log.txt". No ln(0) is avoided by using lin(1), see
    //                 test_ln_of_1. Also my_dB now fixed
    // 22Feb2022 v0613 buffer_task_x fixed so that correct data comes across
    // 21Feb2022 v0612 Using a streaming chan and a knock! to start a sequence removed the deadlock
    //                 mic samples collection has  small pause every 6,5 secs. WHY? It was debug_print
    // 21Feb2022 v0611 I think I have a deadlock with sch_yb, will make it streaming to "knock"
    //                 Commit just to have it stored in case there is something else
    // 20Feb2022 v0610 i2c_hardware_iof_bus gone from all I2C functions, because it's not correct
    //                 therefore if_i2c [I2C_MASTER_ONE_CLIENT] now is a one-dim array
    //                 Constraints tile[0]: C:8/8 T:10/8 C:32/28 M:52660 S: 8320 C:33992 D:10348
    //                 Constraints tile[1]: C:8/4 T:10/4 C:32/ 9 M:35560 S:21732 C:15464 D: 2364
    // 19Feb2022 v0609 See "2022 02 19 10.23 v0609 dB er ganske like OK.JPG"
    // 19Feb2022 v0608 For "2022 02 19 10.11 v0608 xscope.jpg"
    // 18Feb2022 v0607 Both min and max and xScope are fine now. Leaving some test code, to be removed
    //                 This is the first version where long messages are sent across tiles,
    //                 introducing blipping (discovered later), see SEND_LONG_MESSAGE_ACROSS_TILES_INIT in v0622
    // 18Feb2022 v0606 The problem was that I had used UINT when CONTINUOUS in config.xscope. Now xSCOPE works
    //                 showing 180 Hz like Fig.6 in the blog note. But min/max are wrong
    // 18Feb2022 v0605 Commit to test XSCOPE with v0200 again. Getting saturated values with this version.
    // 17Feb2022 v0604 XSCOPE_DO_INIT_MAX_MIN to avoid
    //                 xSCOPE warning ... START/STOP event 0 not called with xscope_start()/xscope_stop()
    //                 mic_sample min max not symmetric, min sometimes positive, also in mics_in_headset_out.xc
    //                 checked with v0200 and it works
    // 17Feb2022 v0603 Just a commit because I want to see old code where dB min and max are equal
    //                 APPLICATION_NOTE=219
    // 16Feb2022 v0602 DO_DISPLAY_INFO_TYPE 2 with mic_sample min max
    // 15Feb2022 v0601 STARTSTOP in config.xscope investigated with DO_XSCOPE_START etc. Works "better"
    // 13Feb2022 v0600 logger.h and logger.xc new. Spectrum is seen on xscope,
    //                 but I truggle with triggering it
    // 11Feb2022 v0514 Now sqrt and dB also run without crash. Now testing starts!
    // 11Feb2022 v0513 mic_samples_buff_t now is a union, instead of trying to use pointer casts. This compiles and runs
    // 10Feb2022 v0512 dsp_math_sqrt(UQ24_MAX) and my_dB 0 = 24.082398 takes 2.89 us test code in dsp_task_y (to be removed)
    // 10Feb2022 v0511 New version of my_dsp_math_multiply_sat now works like it should
    // 09Feb2022 v0510 q24_signed_to_str and uq24_unsigned_to_str are new and solve all Q24 string conversions
    // 08Feb2022 v0509 Finally Q_FORMAT_FRAC is also correct for negative numbers!
    // 08Feb2022 v0508 Better error log, search for uq8_24_nums
    // 08Feb2022 v0507 Testing with values and signed/unsigned param. Crashes on my_dB (128). Just learning about number formats.
    //                 See "2022 02 08 Number formats v0507.pdf"
    // 04Feb2022 v0506 my_dB
    // 04Feb2022 v0505 sprintf_fraction_24bit now makes leading zero as in 1.003 display with them!
    // 02Feb2022 v0504 dsp_handling.h and dsp_handling.xc are now _Beep_dsp_handling.h and _Beep_dsp_handling.xc
    //                 since lib_dsp uses that prfix all over
    // 02Feb2022 v0503 DO_Q24_TEST_CONVERSION and q24_test_conversion_iff new (DEBUG_PRINT_ENABLE_ALL=0 in this compile, so ok float printing)
    // 02Feb2022 v0502 debug_print_full defined for float printing. Q8_24_FLOAT, Q_FORMAT_INT Q_FORMAT_FRAC new
    // 28Jan2022 v0501 Dim 1024: dsp_fft_bit_reverse takes 45 us and dsp_fft_forward 439 us. Staggering!
    // 25Jan2022 v0437 Same as v0436 but with DEBUG_PRINT_GLOBAL_APP 0. Published on the blog
    //                 Constraints tile[0]: C:8/8 T:10/8 C:32/26 M:45132 S: 7464 C:28084 D:9584
    //                 Constraints tile[1]: C:8/3 T:10/3 C:32/ 4 M:21992 S:14500 C: 6956 D: 536
    // 25Jan2022 v0436 dsp_task_y is new and it picks up 1024 samples every 128 ms. Runs. Test code in there.
    //                 xflash'ed.
    //                 Constraints tile[0]: C:8/8 T:10/8 C:32/26 M:47428 S: 8240 C:29116 D:10072
    //                 Constraints tile[1]: C:8/3 T:10/3 C:32/ 5 M:28372 S:15740 C: 8676 D:  956
    // 21Jan2022 v0435 Less printing. xflash'ed
    // 21Jan2022 v0434 I had not incremented on a side mic_sample. Commit with some debug code present. Runs.
    //                 Prints only "Z" and nothing in VERIFY_MIC_SAMPLES_DELTA, pointing towards values a correct linear increase
    // 21Jan2022 v0433 After if (allow_to_send_on_sch_ab) using (phase3_ch_mic_samples.samples.rec_buf.nums.num_samples
    //                 instead of  chan_mutual_packet_dim_prev, since zero_ix_of_all_samples_buffer now run more correctly
    // 20Jan2022 v0432 Sequence OK, but confuses MIC_SAMPLE_VOID on the receiver side
    // 20Jan2022 v0430 Works, but adds a last single mic_sample send as PHASE1->PHASE2->PHASE3,
    //                 probably unavoidable. Scope "2022 01 20 v0430 011.png"
    // 19Jan2022 v0429 Not in goal yet, but at least it doesn't crash, Just a commit
    // 19Jan2022 v0428 The problem is that when batches of NUM_001 or above are sent, the value I have sent along
    //                 for each batch are the newest sample, newer than those not yet sent. So I have to just buffer those
    //                 by adding them to the not sent buffer, and then don't use the value sent when NUM_001 or above.
    //                 On a single button press:
    //                 Y: 549082 (90)
    //                 Y: 549083 (90)
    //                 Y: 549084 (90)
    //                 T:20 549085-549081=4
    // 18Jan2022 v0427 Removed some unnecessary comments. The three lost samples are sent but not but into the buffer
    //                 by --task_b. Logged as:
    //                 x: 183264 (90)
    //                 Y: 183264 (90)
    //                 x: 183265 (90)
    //                 Y: 183265 (90)
    //                 x: 183266 (90)
    //                 Y: 183266 (90)
    //                 T:10 183267-183263=4
    // 18Jan2022 v0426 BEEP-003 Found the 3 LOST samples when button pressed!
    // 17Jan2022 v0425 Now I see that I have a problem with 4 samples on every button push. Maybe I'll solve it tomorrow?
    //                 Five button presses:
    //                 T:0 129530-129526=4
    //                 T:0 140115-140111=4
    //                 T:0 167153-167149=4
    //                 T:0 224623-224619=4
    //                 T:0 272542-272538=4
    // 17Jan2022 v0424 Working on the diff not 1 problem, with VERIFY_MIC_SAMPLES_DELTA. Just a commit, not fixed
    // 17Jan2022 v0423 NUM_MAX_MSG 90
    // 13Jan2022 v0422 Finally got MEMFILL_TYPE_MEMCPY in send_variant_protocol_then_shift_down working!
    //                 Data was overlapping, of course! Had to do segment by segment
    // 13Jan2021 v0421 DISPLAY_MIC_SAMPLES_ARR 1, deltas = 128, 128, 11 (correct)
    //                 v0421 twelve bins containing like: 10 11 12 13 14 15  16 17 18 19 20 21,then [last]-[first]= 11
    //                 See photo
    // 12Jan2022 v0420 SAMPLE_NNN_CNT and DEBUG_MIC_SAMPLES_INCREASING not linaer after button presses
    //                 See log in buffer_task_x
    // 12Jan2022 v0419 DO_DEBUG_PRINT_SPECIAL is new
    //                 buffer_task_x is also quite exciting! Runs
    // 11Jan2022 v0418 buffer_task_x better overview
    //                 Constraints tile[0]: C:8/8 T:10/8 C:32/26 M:64060 S:24816 C:29172 D:10072
    //                 Constraints tile[1]: C:8/2 T:10/2 C:32/3  M:10580 S: 2772 C: 6892 D:  916
    // 09Jan2022 v0417 buffer_task_x is new (not finsihed). Runs on tile[1]
    // 09Jan2022 v0416 Introduced dsp_complex_fill_bufs_init etc, but I will let dsp_fft_split_spectrum do it instead,
    //                 so I will basically remove this code soon
    // 07Jan2022 v0415 Removed F_Pattern_KnockCome.h      and F_Pattern_KnockCome.xc       (empty files)
    //                 Removed F_Pattern_OverflowBuffer.h and F_Pattern_OverflowBuffer.xc  (empty files)
    //                 Renamed maths_fix16.h -> maths_fix.h and maths_fix16.xc -> maths_fix.xc
    //                   (want to do open for MIC_ARRAY_WORD_LENGTH_SHORT=1 and FIX08..)
    // 05Jan2022 v0414 Got rid of everything KnockCome. Implementation F seems ok, but I have not studied the
    //                 data sent across, neither collected them in ..task_b. But I now send like one and one and
    //                 if disturbed by ..task_b blocking, then sending like 128,128,10 values works
    // 04Jan2022 v0413 XFLASHed 0412
    // 04Jan2022 v0412 DO_MEMMOVE 2 and 3 where memcpy WINS by a large margin. Scope 61.png. Still overflow 1 or 2
    // 04Jan2022 v0411 DO_MEMMOVE 1 and NUM_MAX_MSG 128 again. Scope 60.png. memmove not any faster than individual moves?
    // 04Jan2022 v0410 Search for "VER_0410 THIS IS CRITICAL. COMMENTED AWAY. Scope picture 59.png"
    // 04Jan2022 v0409 NUM_MAX_MSG  70. See scope pictures, starting at 57.png
    // 04Jan2022 v0408 NUM_MAX_MSG  92. See scope pictures, starting at 55.png
    // 04Jan2022 v0407 NUM_MAX_MSG 128. See scope pictures, starting at 53.png
    // 04Jan2022 v0406 Implementation F now seems to work, displaying some data in the display. Tested values "limits up and down". Runs
    // 02Jan2022 v0405 I see that at 33 ms I get buffer_full, exactly as planned. Scope. Just some commit
    // 30Dec2021 v0404 rec_max_msg with 128 samples extra sent tested, and takes only 4.us all included. Runs
    // 30Dec2021 v0403 test_streaming_chan_size_t shows more streaming buffered vs. not streaming which is always blocking
    // 30Dec2021 v0402 ==> test_streaming_chan_size_t is streaming working when unsigned [2] but not any larger!! <==
    // 30Dec2021 v0401 OverflowBuffer never implemented. Rudimentary version of "Implementation F" here / (runs)
    // 28Dec2021 v0301 (Same) All instances of "ADC" -> "DAC" (also in this overview)
    // 22Dec2021 v0301 F_Pattern_OverflowBuffer.h F_Pattern_OverflowBuffer.xc new
    // 22Dec2021 v0300 First commit
    //            ---- New branch called OverflowBuffer-BranchOnVer0255 (the OverflowBuffer branch after 0220 not used)
    //                 The reason is that there is more I want with me than I want to get rid of. Even the files F_Pattern_KnockCome files
    // 21Dec2021 v0255 BEEP-002 Studying the CS43L21 data sheet more, for trying to get to 8 kHz also for DAC
    //                          GIVING UP ON KNOCK-COME. The problem with not getting the DAC to run at 8 kHz
    //                          is a secondary problem. See blog note 219
    // 20Dec2021 v0254          SAMPLES_BUF_DIM 128 works, but not 256. This runs.
    // 18Dec2021 v0253 BEEP-001 Searching for problem with no headset DAC out when 8 kHz
    //                          This is ok, 48 kHz. But 8 kHz is not yet
    // 17Dec2021 v0252 OVERSAMPLING_FACTOR is new
    // 15Dec2021 v0251 NUM_TIMEOUTS_BEFORE_SCREEN_DARK now works!
    // 14Dec2021 v0250 SCREEN_ABOUT instead of SCREEN_INIT at power-up
    // 14dec2021 v0249 Exercising p_scope_1i_1m like 0244 is much better
    // 14Dec2021 v0248 p_scope_gray now high while mic_array_get_next_time_domain_frame, it shows much more than just toggling on every sample
    // 13Dec2021 v0247 All details now done, see new scope pictures. Probably to blog note
    // 13Dec2021 v0246 Back to "standard" pulsing of p_scope_gray
    // 13Dec2021 v0245 Extra time (us) used for the first dac out pairs, before the first "no dac out" then back to
    //                 dac out I did find a solution to. Search for "0245": a "half-pair" to the DAC before the loop
    //                 in mics_in_headset_out_task_a
    // 13Dec2021 v0244 See scope photos 2021  12 13 13.30 Beep_BRRR v0244 I cannot understand INIT, which takes so long before Knock! seen
    // 13Dec2021 v0243 See display photos
    // 12Dec2021 v0243 I may have forgottten to commit? (I don't think so, I had removed an [[ordered]] in ..task:b
    // 12Dec2021 v0243 Published in the blog
    // 12Dec2021 v0242 I2C_EXTERNAL_SPEED_K_BITS_PER_SECOND 333 fine, but "Clean Project" first. SPEED_THROUGHPUT_TAG. See scope curves
    // 10Dec2021 v0241 Two scope pins for ..task_a and one for ..task_b. See scope curves
    // 09Dec2021 v0240 See ...Beep_BRRR v0240 display KnockCome measurements.jpg display photos: SPEED_THROUGHPUT_TAG
    // 08Dec2021 v0239 DELAY_FIRST_PRINT_MS is new, solves (USE_XSCOPE == 1) problem
    // 08Dec2021 v0238 More control of printing. xSCOPE only works if debug_print some time after start-up
    //                 See https://www.teigfam.net/oyvind/home/technology/219-my-beep-brrr-notes/#xscope
    // 07Dec2021 v0237 xSCOPE up and running again. DEBUG_PRINT_GLOBAL_APP==1 and one DO_DEBUG_PRINT==1 must probably be set
    //                 warning generated in _globals.h
    // 07dec2021 v0236 Commit before testing xscope on another version
    //                 UPDATE 07Dec2021: xScope does not at all work on this. Compared with 0220
    // 06Dec2021 v0235 Testing the timing of the knock-come "come" phase on the slave side:
    //                 Test result 0235 with SAMPLING_FREQUENCY_HZ = 48000 and LIMIT_USED_TICKS 1483
    //                 Most often around 19-22 ticks (190-220 ns), but as much as 162 (1.6 us) seen.
    //                 mic_result.KnockCome_tics = KnockCome_tics_end - KnockCome_tics_start; // Will be sent next time!
    //                 TODO: write a smaller example and analyse the different timing. Probably something for xta?
    // 05Dec2021 v0234 Testing values of used_tics in mics_in_headset_out.xc:
    //                   Test result 0233 with SAMPLING_FREQUENCY_HZ = 48000 and LIMIT_USED_TICKS 1483
    //                   The first round is much more, but after clear_debug_vars we have these values:
    //                     TEST_SINE_480HZ==1 ->  970 ticks =  9.7 us always below LIMIT_USED_TICKS
    //                                             88 ticks =  0.9 us if headset_gain_is_off
    //                     TEST_SINE_480HZ==0 -> 1120 ticks = 11.2 us always below LIMIT_USED_TICKS
    //                                             90 ticks =  0.9 us if headset_gain_is_off
    // 02dec2021 v0233 TEST_SINE_480HZ makes sense with respect to headset volume
    // 02Dec2021 v0232 used_tics in loop after mic_array_get_next_time_domain_frame is better understood
    // 30Nov2021 v0231 KnockCome mark II
    // 28Nov2021 v0230 KnockCome seems to work!?
    // 23Nov2021 v0221 KnockCome_State introduced, as well as the files F_Pattern_KnockCome.h and .xc
    // 22Dec2021  ---- Made a branch here called OverflowBuffer, but decided to take it from 0255 instead
    //            ---- First on branch knock-come_task_a_with_task_b
    // 21Nov2021 v0220 Compiling with [[ordered]] to test (just one component so far, meaningless)
    //                 UPDATE 07Dec2021: xScope works on this after first button press. Compared with 0236
    // 19Nov2021 v0219 Putting mic_array_get_next_time_domain_frame in a selct case timout instead af just the while(1). Works
    //                 https://www.teigfam.net/oyvind/home/technology/219-my-beep-brrr-notes/#implementation_d
    //          STUDY: "My Beep-BRRR notes" chapter "How many samples out of decimation per time?" at
    //                 https://www.teigfam.net/oyvind/home/technology/219-my-beep-brrr-notes/#how_many_samples_out_of_decimation_per_time
    // 10Nov2021 v0218 Lots of #define names changed name to better understandability
    // 10Nov2021 v0217 Buttons now increase etc. headset gain, display also
    // 09Nov2021 v0216 headset_gain_context filled with button presses. dB not in display yet
    // 08Nov2021 v0215 set_headset_gain and gain in dB steps
    // 05Nov2021 v0214 Nothing special, working with understanding headset gain
    // 03Nov2021 v0213 RUNS. Bidirectional union type data on sch_ab_bidir
    // 02Nov2021 v0212 RUNS also with phase delay, ready for new menu system
    // 01Nov2021 v0211 RUNS! Mics in and headset out. Menu system as old, but now I can start working on it
    // 30Oct2021 v0210 COMPILES BUT NOT TESTED: AN00219 merged into here (=DAC headset out)
    //                 File mics_in and headset_out merged -> mics_in_headset_out
    //                 Only using CONFIG_USE_CHAN for sch_ab_bidir, so both it and CONFIG_USE_INTERFACE removed
    //                 Constraints tile[0]: C:8/8 T:10/8 C:32/23 M:44692 S:8540 C:29772 D:9680
    //                 Constraints tile[1]: C:8/1 T:10/1 C:32/1  M: 6248 S:1084 C: 4700 D: 464
    // 23Oct2021 v0202 Same code as 0201 but
    //                 AN00219_mics_in_headset_out       -> headset_out
    //                 AN00220_app_phase_aligned_example -> mics_in
    // 23Oct2021 v0201 Just a commit before major rethinking. Old files AN00220_app_phase_aligned_example
    //                 and AN00219_mics_in_headset_out (was AN00219_headset_output) will get new names
    // 20Oct2021 v0200 More config into mic_array_conf.h plus now starting to move code from AN00219
    //                 New files AN00219_headset_output.h + .xc. NOT TESTED!
    //                 Update: check with v0604
    // 25Sep2021 v0110 Working with xscope, having some success, but isn't there at all
    // 16Sep2021       Just a build before going to Putten
    // 11Sep2021 v0109 MIC_ARRAY_NUM_MICS to 4, but now it's the negative max value (=min value) of MIC_0 that changes,
    //                 and the positive that is stable at 670763580 (0x27FB0A3C). Why?
    // 11Sep2021 v0108 #error NESTED .h FILE in all files actually caught one!
    //                 The most negative value of MIC_0 is constantly at 2147351294 (0x7FFDFAFE)
    // 10Sep2021 v0107 int32_dB had an unecessary line
    // 09Sep2021 v0106 Constraints tile[0]: C:8/8 T:10/8 C:32/21 M:48656 S:5192 C:28708 D:14756
    //                 Constraints tile[1]: C:8/1 T:10/1 C:32/00 M:1540  S:0348 C:0864  D:00328
    // 09Sep2021 v0106 Configs 01 and 02 removed. CONFIG_USE_INTERFACE new name and CONFIG_USE_CHAN new
    //                 It seems like CONFIG_USE_CHAN does not break timing, I assume because it returns immediately,
    //                 whereas interface does not return before the end of the case
    // 08Sep2021 v0105 Display_screen once per second commented away
    // 08Sep2021 v0104 Much works, but [[combinable]] Handle_Beep_BRRRR_task_b kills timing when it writes to the display
    //                 (Update when on 0106: wrong assumption, it has to do with interface vs. channel)
    //                 Constraints tile[0]: C:8/7 T:10/7 C:32/18 M:49244 S:5116 C:29364 D:14764
    //                 Constraints tile[1]: C:8/1 T:10/1 C:32/00 M:1540  S:0348 C:0864  D:00328
    // 07Sep2021 v0103 MIC_0 sample now sent to display. First version, seems to work?
    //                 CONFIG_TEST_01_BUTTONS_AND_DISPLAY will not compile any more
    // 06Sep2021 v0102 CONFIG_USE_INTERFACE combined. Works.
    // 06Sep2021 v0101 Wrong (see below) As tested on 6Sep2021 v0100 does not run, even if it compiles! But CONFIG_TEST_01_BUTTONS_AND_DISPLAY runs!
    // 25Apr2021 v0100 Running AN00220code in here. Runs (use scope: 8kHz).
    // 13Apr2021 v0013 MIC-ARRAY-1V3.xn now MIC-ARRAY-1V3-MOD.xn with added for xflash which now does not complain:
    //                 PageSize SectorSize NumPages QE_REGISTER QE_BIT
    // 13Apr2021 v0012 This compiles and runs, same as below. See DO_I2C_INIT and PAR_PLACE
    // 13Apr2021 v0011 This compiles and runs, but doing the I2C before the while(1) does not!
    // 13Apr2021 v0010 This compiles and runs, writes to display
    // 09Apr2021 v0009 DO_LINE_2303_CRASH 1 now crashes (compiled with it), but DO_LINE_2303_CRASH 0 compiles
    //                 13Apr2021  reported to XMOS, Ticket "Compiler crash in jenkins file types.cpp, line 2303 (#159996#)"
    // 09Apr2021 v0008 Still crash in "line 2303"
    // 09Apr2021 v0007 xcc1: internal compiler error
    //                 Failed in /jenkins/RELEASE_14_4/sb/tools_xcc1_c_llvm/Common/Types/types.cpp, line 2303
    //                    isTypeInterfaceOrEnd(t)
    // 08Apr2021 v0006 This works, even if there is no debounce in Buttons_demux_task. I can press as fast as
    //                 I want. Should perhaps still make the protocol different, so that I don't have to use
    //                 [[guarded]] void button_changed but not sure how BUTTON_ACTION_PRESSED_FOR_LONG would be
    //                 influenced by it. Now this also works
    // 07Apr2021 v0005 When I, after having made the zip for you, removed the dependency on lib_dsp (not used)
    //                 and cleaned the project and rebuilt, NONE of the four configs will run correctly
    // 07Apr2021 v0004 In main.xc: PAR_PLACE values 0 to 3 either runs fine, compiler crashes in "line 183",
    //                 crashes at runtime and no progress at runtime. Sent to XMOS, ticket #159780#
    // 07Apr2021 v0003 debugging buttons code, not wanting to use the XMOS lib_mic_array_board_support
    // 06Apr2021 v0002 Handle_Beep_BRRRR_task_b etc skeleton up
    // 06Apr2021 v0001 06Apr2021 First commit
#else
    #error NESTED .h FILE
#endif /* VERSION_H_ */
