/*
 * port_tile0_task.h
 *
 * None of the ports on the xCORE MICROPHONE ARRAY board's expansien header are on tile[1]
 * From tasks on tile[1] use this to excercise port(s)
 *
 *  Created on: 7. apr. 2022
 *      Author: oyvindteig
 */


#ifndef PORT_TILE0_TASK_H_
    #define PORT_TILE0_TASK_H_

    typedef enum {
        PORT_1I_1M, // "violet"
        PORT_1D_1N  // "orange"
    } xs1_port_one_of_two_e;

    #define PORT_TILE0_TASK_NUM_CLIENTS 2

    typedef interface port_commands_if {
        void write_port (const xs1_port_one_of_two_e xs1_port, const port_e value_bit0);
    } port_commands_if;


    [[distributable]] // but [[combined]] here since on another tile
    void port_tile0_task (
            server  port_commands_if if_port_commands[PORT_TILE0_TASK_NUM_CLIENTS],
            out port                 p_scope_1i_1m,
            out port                 p_scope_1d_1n);

#else
    #error NESTED .h FILE
#endif /* PORT_TILE0_TASK_H_ */
